/*- - - - - - - - - - - - - - - - - - - - - - - - - - - -
	CALEDIT.H

	TCalendarEdit Class

	Author:     Daniel BERMAN (CompuServe: 100567,3464)
	Date:       09 jully 1995 (1.0)
	Date:       13 jully 1995 (1.01)
	Date:       23 jully 1995 (1.02)
	Date:       16 august 1995 (1.03)

*/

#ifndef _TCalendarEdit_H
#define _TCalendarEdit_H

#include <owl\owlpch.h>
#pragma hdrstop

#include "intldate.h"


class TCalendarBtn;

class TCalendarEdit : public TEdit
{
public:

	TCalendarEdit(TWindow* parent, int id, const char far* text, int x, int y,
					  int w, int h, uint textLen = 0, TModule* module = 0);
	TCalendarEdit(TWindow* parent, int resourceId, uint textLen = 0,
					  TModule* module = 0);
	TCalendarEdit(TGadgetWindow* parent, int id, int w);
	~TCalendarEdit();

	const TIntlDate&					GetDate();

   void									SetText(const TIntlDate& date);
	void									SetText(const char far* str);

	static TIntlDate::HowToSpeak	SetLanguage(TIntlDate::HowToSpeak l);

protected:

	void SetupWindow();

	void EvChar(uint key, uint repeatCount, uint flags);
	void EvKeyDown(uint key, uint repeatCount, uint flags);
	void EvKillFocus(HWND hWndGetFocus);
	void EvSize(uint sizeType, TSize& size);

private:

	TFont* Font;
	TCalendarBtn* CalBtn;

	void Init();

	DECLARE_RESPONSE_TABLE(TCalendarEdit);
};


class TDateValidator : public TValidator
{
public:

	TDateValidator();

	void Error();
	bool IsValid(const char far* str);
};


#endif
