/*- - - - - - - - - - - - - - - - - - - - - - - - - - - -
	TEST.CPP

	Test program for TCalendarEdit Class

	Author:     Daniel BERMAN (CompuServe: 100567,3464)
	Date:       09 jully 1995 (1.0)
	Date:       13 jully 1995 (1.01)
	Date:       23 jully 1995 (1.02)
	Date:       16 august 1995 (1.03)

*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "caledit.h"
#include "test.rc"


class TDlg : public TDialog
{
public:

	TStatic* hlp;

	TDlg() : TDialog(0, IDD_MAIN)
	{
		TCalendarEdit* calEdit = new TCalendarEdit(this, IDC_EDIT);
//		calEdit->SetValidator(new TDateValidator);
		hlp = new TStatic(this, IDC_HLP);
	}

	void SetupWindow()
	{
		TDialog::SetupWindow();
		hlp->SetText("Keyboard navigation:\n"
						 "  up\t\t\t\t= previous week\n"
						 "  down\t\t\t\t= next week\n"
						 "  left\t\t\t\t= previous day\n"
						 "  right\t\t\t\t= next day\n"
						 "  home\t\t\t\t= first day of month\n"
						 "  end\t\t\t\t= last day of month\n"
						 "  page up\t\t\t= previous month\n"
						 "  page down\t\t\t= next month\n"
						 "  Ctrl + home\t\t\t= first day of year\n"
						 "  Ctrl + end\t\t\t= last day of year\n"
						 "  Ctrl + page up\t\t\t= previous year\n"
						 "  Ctrl + page down\t\t= next year\n"
						 "  Enter, space bar, Escape\t= close the calendar popup\n"
						 "  Multiply (*)\t\t\t= today's date");
	}
};


class TApp : public TApplication
{
public:

	TApp(const char far* name) : TApplication(name) {}

	void InitMainWindow()
	{
		TDecoratedFrame* frame = new TDecoratedFrame(0, GetName(), new TDlg);
		TControlBar* cb = new TControlBar(frame);

		cb->Insert(*new TButtonGadget(CM_EXIT, CM_EXIT));
		cb->Insert(*new TSeparatorGadget(30));
		cb->Insert(*new TControlGadget(*new TCalendarEdit(cb, 110, 100)));
		cb->Insert(*new TSeparatorGadget(30));
		cb->Insert(*new TButtonGadget(CM_ABOUT, CM_ABOUT));

		frame->Insert(*cb, TDecoratedFrame::Top);

		SetMainWindow(frame);
	}
};


int OwlMain(int, char* [])
{
	// French support
//	TCalendarEdit::SetLanguage(TIntlDate::French);

	return TApp("TCalendarEdit  Daniel BERMAN").Run();
}


